#pragma once

#include <iostream>

#include "File.h"
#include "Record.h"

struct Application {
    void run() {
        File f("Flats");
        Record record1, record2;
        int temp_int;
        std::string temp_str;
        bool is_running = true;
        int k;
        while (is_running) {
            std::cout << std::endl << "1 add flat" << std::endl
                      << "2 search flats by house number" << std::endl
                      << "3 search flats by flat number" << std::endl
                      << "4 search flats by owner" << std::endl
                      << "5 search flats by operation type" << std::endl
                      << "6 search flats by operation type" << std::endl
                      << "7 delete flat" << std::endl
                      << "8 change flat" << std::endl
                      << "9 load to txt file" << std::endl
                      << "10 exit" << std::endl << ">>>";
            std::cin >> k;
            std::cout << std::endl;

            switch (k)
            {
                case 1:
                    std::cout << "Input flat to add" << std::endl;
                    std::cin >> record1;
                    f.AddToFile(record1);
                    std::cout << "OK" << std::endl;
                    break;
                case 2:
                    std::cout << "Input house number to search" << std::endl;
                    std::cin >> temp_int;
                    f.SearchByHouseN(temp_int);
                    std::cout << "Result saved in file \"" << temp_int << "_house\"" << std::endl;
                    break;
                case 3:
                    std::cout << "Input flat number to search" << std::endl;
                    std::cin >> temp_int;
                    f.SearchByFlatN(temp_int);
                    std::cout << "Result saved in file \"" << temp_int << "_flat\"" << std::endl;
                    break;
                case 4:
                    std::cout << "Input owner's surname to search" << std::endl;
                    std::cin >> temp_str;
                    f.SearchBySecondName(temp_str);
                    std::cout << "Result saved in file \"" << temp_str << "_owner\"" << std::endl;
                    break;
                case 5:
                    std::cout << "Input operation type to search" << std::endl;
                    std::cin >> temp_str;
                    f.SearchByOperType(temp_str);
                    std::cout << "Result saved in file \"" << temp_int << "_operation\"" << std::endl;
                    break;
                case 6:
                    std::cout << "Input date to search" << std::endl;
                    std::cin >> temp_str;
                    f.SearchByDate(temp_str);
                    std::cout << "Result saved in file \"" << temp_int << "_date\"" << std::endl;
                    break;
                case 7:
                    std::cout << "Input index of flat to delete" << std::endl;
                    std::cin >> temp_int;
                    f.DelFromFile(temp_int);
                    std::cout << "Result saved in file \"" << temp_int << "\"" << std::endl;
                    break;
                case 8:
                    std::cout << "Input index of flat to change" << std::endl;
                    std::cin >> temp_int;
                    std::cout << "Input flat to insert" << std::endl;
                    std::cin >> record2;
                    f.Replace(temp_int, record2);
                    std::cout << "OK" << std::endl;
                    break;
                case 9:
                    f.ToText();
                    std::cout << "Flats saved in \"Flats\"" << std::endl;
                    break;
                case 10:
                    is_running = false;
                    break;
                default:
                    std::cout << "invalid option" << std::endl;
                    break;
            }
        }
    }
};
